local ScenarioUtils = import('/lua/sim/ScenarioUtilities.lua')
local ScenarioFramework = import( '/lua/ScenarioFramework.lua' )

local executing = false
local beatTime = 2
local com_cybran = nil
local loyal = nil
local gameEnd = false
local Num_Position = 0

Dial_Intro_Fr = {
  {text = "[{i Dostya}]: Bonjour Commander. Nous sommes en crise , un Acu a été capturé par L'UEF. Nous avons peu d'effectif, désolé , mais vous devez récupérer cette armure ... Le pilote de l'ACU n'attend qu'une chose : réintégrer sa cabine. On l'a mis dans une unité loyaliste de fortune pour cela. Amenez le donc auprès de l'ACU. Dostya Terminé", vid = 'C04_Dostya_M03_0491.sfd', bank = '', cue = '', faction = 'Cybran'},
}

Dial_Intro_En = {
  {text = "[{i QAI}]: Translation : Hi Commander. We are on crisis, an Acu was captured by UEF. We don't have more troops, so you must recuperate this armor ... The ACU driver is ready to enter his ACU. Meanwhile he is in a pity loyalist unit. Bring him near the ACU. Good luck", vid = 'C06_Qai_M02_00580.sfd', bank = '', cue = '', faction = 'Cybran'},
}


printf = function(text)
	PrintText(text,20,nil,5,'center') 		
end

function OnPopulate()

  Num_Position = Random(1,3)

  ScenarioInfo.Options.Victory = 'sandbox'
  ScenarioInfo.Options.TeamSpawn = 'fixed'
  ScenarioInfo.Options.TeamLock = 'locked'
  ScenarioInfo.Options.FogOfWar = 'unexplored' 
  ScenarioInfo.Options.CivilianAlliance = 'neutral' 
  ScenarioInfo.Options.CheatsEnabled = 'false' 
  ScenarioInfo.Options.NoRushOption = 'Off' 
  ScenarioInfo.Options.PrebuiltUnits = 'Off' 

  local tblArmy = ListArmies()
  local tblGroups = {}
  
  for iArmy, strArmy in pairs(tblArmy) do
    local tblData = Scenario.Armies[strArmy]
    tblGroups[ strArmy ] = {}
  end

--  ScenarioUtils.InitializeArmies()

end

function OnStart(self)

  local b_army1 = 0
  local b_army2 = 0
  local b_army3 = 0

  local unite = nil
  
  ScenarioFramework.Dialogue(Dial_Intro_Fr)
  ScenarioFramework.Dialogue(Dial_Intro_En)
  
  SetAlliance( 'ARMY_4', 'ARMY_5', 'Neutral')
  
  -- tout le monde est ally avec tout le monde, sauf army_4
  for index,army in ListArmies() do
    if army != 'ARMY_4' and army != 'ARMY_5' then
      for index2,army2 in ListArmies() do
        if army2 != 'ARMY_4' and army != 'ARMY_5' then
          SetAlliance( army, army2, 'Ally')
        else
          SetAlliance( army, army2, 'Enemy')
        end
      end
    end
    SetAlliance( army, 'ARMY_5', 'Neutral')
    if army == 'ARMY_1' then
      b_army1 = 1
    elseif army == 'ARMY_2' then
      b_army2 = 1
    elseif army == 'ARMY_3' then
      b_army3 = 1
    end
	end
  
  local NomArmy = nil
  --unite de l'armée 1
  if b_army1 == 1 then
    NomArmy = 'ARMY_1'
  elseif b_army2 == 1 then
    NomArmy = 'ARMY_2'
  else
    NomArmy = 'ARMY_3'
  end    
  unite = CreateUnitHPR('url0101', NomArmy, 49.72, 55.99, 9.47, 0,0,0)  
  unite:SetIntelRadius('Radar',3)
  unite:SetIntelRadius('Vision',10)
  unite:DisableIntel('Radar')
  
  unite = CreateUnitHPR('url0101', NomArmy, 49.72, 55.99, 9.47, 0,0,0)  
  unite:SetIntelRadius('Radar',3)
  unite:SetIntelRadius('Vision',10)
  unite:DisableIntel('Radar')

  unite = CreateUnitHPR('url0101', NomArmy, 45.52, 56.18, 7.40, 0,0,0)  
  unite:SetIntelRadius('Radar',3)
  unite:SetIntelRadius('Vision',10)
  unite:DisableIntel('Radar')
  
  unite = CreateUnitHPR('url0101', NomArmy, 45.52, 56.18, 7.40, 0,0,0)  
  unite:SetIntelRadius('Radar',3)
  unite:SetIntelRadius('Vision',10)
  unite:DisableIntel('Radar')

  CreateUnitHPR('urb1101', NomArmy, 47.50, 55.99, 6.90, 0,0,0)  
  CreateUnitHPR('urb1101', NomArmy, 51.93, 55.99, 8.36, 0,0,0)

    
  -- unité de l'armée 2
  if b_army2 == 1 then
    NomArmy = 'ARMY_2'
  elseif b_army1 == 1 then
    NomArmy = 'ARMY_1'
  else
    NomArmy = 'ARMY_3'
  end 

  unite = CreateUnitHPR('url0107', NomArmy, 45.52, 56.18, 7.40, 0,0,0)  
  unite:SetIntelRadius('Vision',10)
  unite:GetWeapon(1):ChangeMaxRadius(8)

  unite = CreateUnitHPR('url0107', NomArmy, 45.52, 56.18, 7.40, 0,0,0)  
  unite:SetIntelRadius('Vision',10)
  unite:GetWeapon(1):ChangeMaxRadius(8)

  unite = CreateUnitHPR('url0107', NomArmy, 45.52, 56.18, 7.40, 0,0,0)  
  unite:SetIntelRadius('Vision',10)
  unite:GetWeapon(1):ChangeMaxRadius(8)

  unite = CreateUnitHPR('url0107', NomArmy, 49.72, 55.99, 9.47, 0,0,0)  
  unite:SetIntelRadius('Vision',10)
  unite:GetWeapon(1):ChangeMaxRadius(8)

  
  -- unité de l'armée 3
  if b_army3 == 1 then
    NomArmy = 'ARMY_3'
  elseif b_army1 == 1 then
    NomArmy = 'ARMY_1'
  else
    NomArmy = 'ARMY_2'
  end 
  unite = CreateUnitHPR('url0303', NomArmy, 53.55, 55.99, 7.54, 0,0,0) 
  
  unite:SetMaxHealth(400)
	unite:SetHealth(nil,400)
  unite:GetWeapon(1):ChangeDamage(5)
  unite:GetWeapon(2):ChangeDamage(1)
  unite:GetWeapon(1):ChangeMaxRadius(8) 
  unite:GetWeapon(2):ChangeMaxRadius(8) 
  unite:SetIntelRadius('Radar',1)
  unite:SetIntelRadius('Vision',10)
  loyal = unite
  
  --unité de l'armée 4
  --pow gen t2
  unite = CreateUnitHPR('urb1201', 'ARMY_4', 0.06, 68.66, 6.23, 0,0,0)
  makeInvincible(unite)
  --stealth field gen
  unite = CreateUnitHPR('urb4203', 'ARMY_4', 0.15, 67.79, 17.38, 0,0,0)
  unite:SetIntelRadius('RadarStealthField',1000)
  makeInvincible(unite)
  --units
  local aiBrain = GetArmyBrain('ARMY_4')
  local attackPlatoon = nil
  
  local marker1 = nil
  local markerP = nil
  
  for i = 1, 14 do
    marker1 = ScenarioUtils.GetMarker('UNIT_' .. i)['position']
    markerP = ScenarioUtils.GetMarker('UNIT_' .. i ..'P')['position']
    unite = CreateUnitHPR('uel0106', 'ARMY_4', marker1[1], marker1[2], marker1[3], 0,0,0)
    attackPlatoon = aiBrain:MakePlatoon('','')
    aiBrain:AssignUnitsToPlatoon(attackPlatoon, {unite}, 'Attack', 'GrowthFormation')
    attackPlatoon:Patrol(marker1)
    attackPlatoon:Patrol(markerP)
  end

  --unité de l'armée 5
  marker1 = ScenarioUtils.GetMarker('COM_' .. Num_Position)['position']
  unite = CreateUnitHPR('url0001', 'ARMY_5', marker1[1], marker1[2], marker1[3], 0,0,0)
  --cessez le feu
  unite:ToggleFireState()
  unite:SetIntelRadius('Radar',0)
  unite:SetIntelRadius('Omni',0)
  unite:SetIntelRadius('Vision',0)
  unite:DisableIntel('Radar')
  unite:DisableIntel('Omni')
  makeInvincible(unite)
  com_cybran = unite
  
  --start main thread
	local mainThread = ForkThread(function()
		while not gameEnd do
			--secutiry for slow computers
			while executing == true do
			end
			--call main thread beat
			mainThreadBeat()
			--wait time between each beat
			WaitSeconds(beatTime)
		end
    end)
end

--MAIN SCENARIO THREAD
--do map script actions every TICK
mainThreadBeat = function()
	executing = true
	checkVictoryConditions()
	executing = false
end

checkVictoryConditions = function()
	
  --check for victory
  local unitsInZone = GetUnitsInRect(ScenarioUtils.AreaToRect('FINISH_' .. Num_Position))
  if unitsInZone then
		for k,unit in unitsInZone do
			if not unit:IsDead()  then
        if unit == loyal then
        for index,army in ListArmies() do
            if army == 'ARMY_1' or army == 'ARMY_2' or army == 'ARMY_3' then
              GetArmyBrain(army):OnVictory()
            end
          end
          gameEnd = true
        end
			end
		end
	end

  --check for defeat
  if loyal:IsDead() then
    for index,army in ListArmies() do
      if army == 'ARMY_1' or army == 'ARMY_2' or army == 'ARMY_3' then
        GetArmyBrain(army):OnDefeat()
        gameEnd = true
      end
    end
  end
  
end


makeInvincible = function(unit)		
	unit:SetDoNotTarget(true)
	unit:SetCanBeKilled(false)
	unit:SetCapturable(false)
	unit:SetReclaimable(false)
	unit:SetDoNotTarget(true)
	unit:SetMaxHealth(10000)
	unit:SetHealth(nil,10000)
	unit:SetRegenRate(10000)
end

